---
title: "Login"
date: 2023-08-02T07:17:50+07:00
draft: false
weight: 7
---

Before you begin exploring our rapid prototyping environment for Vehicle Apps, let's ensure you're familiar with our login process. Follow this step-by-step guide for a smooth start:

_Click "Login" in the top right conner of the [playground homepage](https://digitalauto.netlify.app/) to open the login popup._

![Entry Login](./images/entry_login.png)

### 1. Login

From here, you can:

- **Log In**: If you already have an account, click on the "Login" button, and follow below procedure.

- **Sign Up**: New around here? No worries. Then refer to the ["Sign-up"](#2-sign-up) section below for a guided walk-through.

- **Forgot Password?**: Can't remember your password? Then process to the ["Forgot Password"](#3-forgot-password) section for assistance.

![Login Popup](./images/login_popup.png)

#### <span id="login">Steps: </span>

1. **Email**: Input your registered email.
2. **Password**: Enter your account password.
3. Click the **"Login"** button.

💡 **Quick Tip**: You can swiftly log in with your GitHub credentials. Click on the **"Continue with GitHub"** option for immediate access.

### 2. Sign Up

Are you new here? Let's get you set up.

_If you don't have an account yet, simply click "Don't have an account? Sign Up" from the Login popup._

![Sign Up Popup](./images/signup.png)

#### Steps:

1. **Name**: Provide your full name.
2. **Email**: Use a valid email address.
3. **Password**: Choose a strong password.
4. **Confirm Password**: Re-enter your password for accuracy.
5. **CAPTCHA**: Please complete the CAPTCHA to verify.
6. Click the **"Sign Up"** button to create your account.

<!-- ### 3. <span id="forgot-password">Forgot Password </span> -->
### 3. Forgot Password

Forgot your credentials? We've got your back.

_Select "Forgot Password" to reset your password._

![Forgot Password Popup](./images/forgotpassword.png)

#### Steps:

1. **Retrieve Email**: Input the email you registered with.
2. **CAPTCHA**: Complete the CAPTCHA check.
3. Click the **"Confirm"** button, and we'll send you reset instructions.

If you recall your password while here, simply choose **"Back to Login."**
