---
title: "Onboarding"
date: 2023-08-03T06:48:57+07:00
draft: false
weight: 2
---

Before you can build, test and submit your genAI, you need to register your team first.

1. Go to https://genai.digital.auto/ 

2. You need to login first to do further steps. You can login with a GitHub account.
   ![Onboarding](https://bewebstudio.digitalauto.tech/data/projects/nTcRsgxcDWgr/GenAI-Awards/onboarding.png)

3. Fill your team's information. Every team member should already have an account. Your team can have up to 5 members.
   ![Step 1 - Register team](https://bewebstudio.digitalauto.tech/data/projects/nTcRsgxcDWgr/GenAI-Awards/register-team.png)
   **NOTE:** The campain is limited to **NON**employee of companies in the list of sponsorship. 

5. Apply for Amazon Web Service Bedrock credits.

    4.1. Apply for AWS Bedrock credits. This is to get **free** credits from AWS - as one major sponsor of the campain - for your genAI development and testing. Providing a clear **description of your general idea** in step 3 is crucial for evaluation. Failing to adequately describe your idea may result in being denied access to AWS Bedrock. Optionally, you can choose to use your own generative AI service if you don't like to get credit for **free**.
    ![Step 2.1 - Apply for Bedrock credits](https://bewebstudio.digitalauto.tech/data/projects/nTcRsgxcDWgr/GenAI-Awards/apply-credits.png)

    4.2. Waiting for approval. The review process can take up to 24 hours. If approved, we will send a email to inform you.
    ![Step 2.2 - Waiting for approval](https://bewebstudio.digitalauto.tech/data/projects/nTcRsgxcDWgr/GenAI-Awards/waiting-for-approval.png)

6. Review your team. Once your application is approved, you can find your credentials here. We provide you IAM user and password to login to AWS console. Please be noted that access key and secret here cannot use for calling Amazon Web Service APIs due to some security issues, they are only used for submitting your GenAI.

    ![Step 3 - Review your team](https://bewebstudio.digitalauto.tech/data/projects/nTcRsgxcDWgr/GenAI-Awards/review-team.png)
