---
title: "Overview dreamKIT"
date: 2023-08-03T07:27:00+07:00
draft: false
weight: 5
---

The digital.auto dreamKIT is a proof-of-concept (PoC) hardware, providing a hands-on, physical experience for SDV applications. With the dreamKIT you can try out your digitally developed SDV features on a physical device. Therefore, it allows you to transfer your use case from the virtual exploration phase into the productization phase.

dreamKIT is a candidate for [SDV Alliance Integration Blueprint](https://covesa.global/wp-content/uploads/2024/04/SDV-alliance-announcement-20230109.pdf). Check it out the latest COVESA white paper release [here](https://covesa.global/wp-content/uploads/2024/05/SDV-Alliance-Integration-Blueprint-20240109.pdf)

Should you have any specific interest on dreamKIT, please give us feedback here https://forms.office.com/e/BiJcMEhbBy

The digital.auto dreamKIT includes a vehicle computing unit, a central gateway, and a mock-up in-vehicle infotainment touch screen. dreamKIT has CAN and Ethernet interfaces to connect with external devices, that can form a Zonal E/E Architecture network topology.

The dreamKIT is a proven PoC device, which is used in multiple international show cases, as well as in different co-innovation challenges for software engineers.

Feature overview for development, experimentation, and innovation:

- Seamless integration with playground.digital.auto: SDV applications developed on playground could be deployed to the dreamKIT within seconds, wirelessly using socketIO technology.
- Built in SDV runtime environment: powered by Eclipse SDV solutions.
- Ease of customizing and experimenting a zonal EE architecture: dreamKIT has built-in central gateway – which has CAN/ CANFD and Ethernet interfaces - to connect and expand the network topology to different zone controller ECUs
- Ease of connecting an AUTOSAR embedded ECU: dreamKIT has a SDV runtime environment, that with minimal configuration (via OTA) could recognize and integrate with an external device.



![playground to dreamKIT](./images/playground-dreamKIT.png)

![seamless deployment](./images/Seamless_deployment.png)

{{< youtube -DdnHqg3Qeg >}}
